diff --git a/lib/hive/web/runtime_layout.rb b/lib/hive/web/runtime_layout.rb
new file mode 100644
index 00000000..ec7d0046
--- /dev/null
+++ b/lib/hive/web/runtime_layout.rb
@@ -0,0 +1,141 @@
+require "digest"
+require "fileutils"
+require "json"
+require "rbconfig"
+require "securerandom"
+require "time"
+
+require "hive"
+require "hive/paths"
+
+module Hive
+  module Web
+    # Filesystem contract for the installed Rails application.  A gem/Homebrew
+    # cellar is package-owned and can be read-only, so *all* mutable Rails
+    # state belongs below XDG.  The versioned directory also lets a failed
+    # upgrade leave the last completed runtime untouched.
+    class RuntimeLayout
+      MANIFEST_FILE = ".hive-web-runtime.json".freeze
+
+      attr_reader :version, :package_root
+
+      def initialize(version: Hive::VERSION, package_root: nil)
+        @version = version.to_s
+        @package_root = File.expand_path(package_root || self.class.package_root)
+      end
+
+      def self.package_root
+        # This file lives at <gem>/lib/hive/web/runtime_layout.rb in a normal
+        # install and at <checkout>/lib/... in development.  Do not use cwd:
+        # a managed unit has no useful working directory.
+        File.expand_path("../../..", __dir__)
+      end
+
+      def runtime_root
+        File.join(Hive::Paths.data_home, "web")
+      end
+
+      def app_dir
+        File.join(runtime_root, version)
+      end
+
+      def bundle_path
+        File.join(app_dir, "bundle")
+      end
+
+      def assets_path
+        File.join(app_dir, "public", "assets")
+      end
+
+      def tmp_path
+        File.join(app_dir, "tmp")
+      end
+
+      def log_path
+        File.join(app_dir, "log")
+      end
+
+      def storage_path
+        File.join(Hive::Paths.state_home, "web-storage")
+      end
+
+      def source_app_dir
+        File.join(package_root, "web")
+      end
+
+      def manifest_path
+        File.join(app_dir, MANIFEST_FILE)
+      end
+
+      def staging_dir
+        "#{app_dir}.staging-#{Process.pid}-#{SecureRandom.hex(6)}"
+      end
+
+      def source_available?
+        File.file?(File.join(source_app_dir, "config", "application.rb")) &&
+          File.file?(File.join(source_app_dir, "Gemfile.lock"))
+      end
+
+      def rails_app?
+        File.file?(File.join(app_dir, "config", "application.rb"))
+      end
+
+      def completed?(identity)
+        return false unless rails_app? && File.file?(manifest_path)
+
+        manifest = JSON.parse(File.read(manifest_path))
+        manifest["identity"] == identity
+      rescue JSON::ParserError, SystemCallError
+        false
+      end
+
+      def identity
+        {
+          "version" => version,
+          "lockfile_sha256" => digest_file(File.join(source_app_dir, "Gemfile.lock")),
+          "app_sha256" => tree_digest(source_app_dir),
+          "ruby" => RUBY_DESCRIPTION,
+          "bundle_path" => bundle_path
+        }
+      end
+
+      # Atomic enough for one user's setup process: consumers see either the
+      # old complete version or the new complete version.  Keep a timestamped
+      # previous directory instead of deleting it in the success path; a later
+      # setup can clean old versions after it has a known-good replacement.
+      def promote!(staging)
+        FileUtils.mkdir_p(runtime_root)
+        if File.exist?(app_dir)
+          previous = "#{app_dir}.previous-#{Time.now.utc.strftime('%Y%m%dT%H%M%S%6NZ')}"
+          File.rename(app_dir, previous)
+        end
+        File.rename(staging, app_dir)
+        app_dir
+      end
+
+      def cleanup_previous!(retain: 2)
+        previous = Dir["#{app_dir}.previous-*"] .sort.reverse
+        previous.drop(retain).each { |path| FileUtils.rm_rf(path) }
+      end
+
+      private
+
+      def digest_file(path)
+        ::Digest::SHA256.file(path).hexdigest
+      end
+
+      def tree_digest(root)
+        digest = ::Digest::SHA256.new
+        Dir.glob(File.join(root, "**", "*"), File::FNM_DOTMATCH).sort.each do |path|
+          next if File.directory?(path)
+          relative = path.delete_prefix("#{root}/")
+          next if [ ".", ".." ].include?(relative)
+
+          digest << relative << "\0"
+          digest << File.binread(path)
+        end
+        digest.hexdigest
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/supervisor.rb b/lib/hive/web/supervisor.rb
index 510a66d4..97351584 100644
--- a/lib/hive/web/supervisor.rb
+++ b/lib/hive/web/supervisor.rb
@@ -34,7 +34,9 @@ module Hive
         ENV["HIVEBOX_SUPERVISOR_PID"] = Process.pid.to_s
         previous_signal_handlers = trap_signals
         start_child("daemon", %w[hive daemon start])
-        start_child("web", %w[hive web --bind 0.0.0.0])
+        # Hivebox remains owner-authenticated even though native local mode
+        # resolves auto to authless on a loopback-only bind.
+        start_child("web", %w[hive web --bind 0.0.0.0 --auth github])
         start_child("bot", %w[hive bot start --foreground]) if bot_enabled?
         loop do
           break if @stopping
diff --git a/packaging/aur/hive.install b/packaging/aur/hive.install
index dff4a6a4..df1c41dc 100644
--- a/packaging/aur/hive.install
+++ b/packaging/aur/hive.install
@@ -1,7 +1,9 @@
 post_install() {
   cat <<'MSG'
 hive-bin installed.
-Run `hive daemon install` once to install and enable the user daemon, then run `hive init` in a project to scaffold .hive-state and choose project enrollment.
+From a checked-out project, run `hive setup .` to provision the local Rails UI,
+enroll the project, and install/start separate daemon and web services. Missing
+external prerequisites are reported with repair commands and are not installed automatically.
 MSG
 }
 
diff --git a/packaging/verify-release.sh b/packaging/verify-release.sh
index a66153ea..1346e752 100755
--- a/packaging/verify-release.sh
+++ b/packaging/verify-release.sh
@@ -303,6 +303,36 @@ else
   fail "install-channel sidecar missing at $XDG_DATA_HOME/hive/install-channel"
 fi
 
+# The Rails app and native web-unit templates are part of the gem payload, not
+# checkout-only files. Locate the installed gem directly (the bash wrapper has
+# a private GEM_HOME) and pin the files required for `hive setup` to stage a
+# writable local runtime on a clean machine.
+step "packaged local web payload"
+WEB_GEM_ROOT="$(find "$XDG_DATA_HOME/hive/gems/gems" -maxdepth 1 -type d -name 'hive-cli-*' -print -quit 2>/dev/null || true)"
+if [[ -z "$WEB_GEM_ROOT" ]]; then
+  fail "installed hive-cli gem root was not found under $XDG_DATA_HOME/hive/gems/gems"
+else
+  web_required=(
+    web/Gemfile web/Gemfile.lock web/bin/rails web/config/application.rb
+    web/config/database.yml web/db/cache_schema.rb
+    examples/systemd/hive-web.service examples/launchd/hive-web.plist
+  )
+  web_missing=0
+  for web_path in "${web_required[@]}"; do
+    if [[ -f "$WEB_GEM_ROOT/$web_path" ]]; then
+      ok "packaged web payload: $web_path"
+    else
+      fail "installed gem is missing local web payload: $web_path"
+      web_missing=1
+    fi
+  done
+  if [[ "$web_missing" -eq 0 && -x "$WEB_GEM_ROOT/web/bin/rails" ]]; then
+    ok "packaged web/bin/rails is executable"
+  else
+    fail "packaged web/bin/rails is not executable"
+  fi
+fi
+
 # ─── 2. doctor ───────────────────────────────────────────────────────
 
 step "hive doctor"
diff --git a/test/integration/gem_package_scripts_test.rb b/test/integration/gem_package_scripts_test.rb
index ff2ba7e5..6436b46d 100644
--- a/test/integration/gem_package_scripts_test.rb
+++ b/test/integration/gem_package_scripts_test.rb
@@ -10,6 +10,12 @@ class GemPackageScriptsTest < Minitest::Test
     "lib/hive/claude_launcher.rb",
     "lib/hive/stop_hook_installer.rb"
   ].freeze
+  WEB_RUNTIME_FILES = [
+    "web/Gemfile", "web/Gemfile.lock", "web/bin/rails",
+    "web/config/application.rb", "web/config/database.yml",
+    "web/db/cache_schema.rb", "examples/systemd/hive-web.service",
+    "examples/launchd/hive-web.plist"
+  ].freeze
 
   def test_built_gem_contains_all_claude_launcher_script_references
     skip "gem executable unavailable" unless executable_available?("gem")
@@ -36,6 +42,23 @@ class GemPackageScriptsTest < Minitest::Test
     end
   end
 
+  def test_built_gem_contains_the_complete_local_web_payload
+    skip "gem executable unavailable" unless executable_available?("gem")
+
+    Dir.mktmpdir("hive-test") do |dir|
+      gem_path = File.join(dir, "hive-cli.gem")
+      stdout, stderr, status = Open3.capture3("gem", "build", GEMSPEC_PATH, "--output", gem_path, chdir: ROOT)
+      assert status.success?, "gem build failed\nstdout:\n#{stdout}\nstderr:\n#{stderr}"
+
+      package = Gem::Package.new(gem_path)
+      WEB_RUNTIME_FILES.each { |path| assert_includes package.spec.files, path }
+      extracted = File.join(dir, "extracted")
+      package.extract_files(extracted)
+      rails = File.join(extracted, "web/bin/rails")
+      assert File.executable?(rails), "web/bin/rails must remain executable in the built artifact"
+    end
+  end
+
   private
 
   def claude_launcher_script_references
diff --git a/test/unit/commands/daemon/service_installer_test.rb b/test/unit/commands/daemon/service_installer_test.rb
index 681a6af3..3a029157 100644
--- a/test/unit/commands/daemon/service_installer_test.rb
+++ b/test/unit/commands/daemon/service_installer_test.rb
@@ -252,6 +252,26 @@ class DaemonServiceInstallerTest < Minitest::Test
     end
   end
 
+  def test_rendered_units_preserve_custom_xdg_roots
+    with_tmp_dir do |dir|
+      with_env(
+        "XDG_CONFIG_HOME" => File.join(dir, "config root"),
+        "XDG_DATA_HOME" => File.join(dir, "data root"),
+        "XDG_STATE_HOME" => File.join(dir, "state root"),
+        "XDG_CACHE_HOME" => File.join(dir, "cache root")
+      ) do
+        installer = Hive::Commands::Daemon::ServiceInstaller.new(
+          host_os: "linux", home: dir, binary_path: "/tmp/hive", systemctl_available: false
+        )
+        installer.install!(autostart: false)
+        unit_body = File.read(installer.target_path)
+
+        assert_includes unit_body, "XDG_CONFIG_HOME=#{File.join(dir, 'config root')}"
+        assert_includes unit_body, "XDG_STATE_HOME=#{File.join(dir, 'state root')}"
+      end
+    end
+  end
+
   # ── Ruby version-manager shim detection (PR #113 follow-up) ────────────
   # The gem's bin/hive uses `#!/usr/bin/env ruby`. The unit's baked
   # PATH must include the active Ruby manager's shim dir so the
diff --git a/test/unit/commands/daemon_test.rb b/test/unit/commands/daemon_test.rb
index f87b788e..d50f9f21 100644
--- a/test/unit/commands/daemon_test.rb
+++ b/test/unit/commands/daemon_test.rb
@@ -294,6 +294,8 @@ class HiveCommandsDaemonTest < Minitest::Test
     doc = JSON.parse(out)
     assert_equal true, doc.fetch("running")
     assert_equal 1234, doc.fetch("pid")
+    assert_equal "unknown", doc.dig("daemon_identity", "state"),
+                 "old test payloads deliberately model a pre-identity daemon"
     assert_operator doc.fetch("uptime_sec"), :>=, 0
   end
 
@@ -953,6 +955,8 @@ class HiveCommandsDaemonTest < Minitest::Test
     payload = command.send(:pid_file_payload, 456, "supplied")
     assert_equal 456, payload.fetch("pid")
     assert_equal "supplied", payload.fetch("process_start_time")
+    identity = command.send(:pid_file_payload, 456, "supplied", identity: { "hive_version" => "1.2.3" })
+    assert_equal "1.2.3", identity.fetch("hive_version")
   end
 
   def test_read_live_pid_requires_alive_pid_owned_by_this_daemon
diff --git a/test/unit/commands/setup/preflight_test.rb b/test/unit/commands/setup/preflight_test.rb
new file mode 100644
index 00000000..d0934824
--- /dev/null
+++ b/test/unit/commands/setup/preflight_test.rb
@@ -0,0 +1,46 @@
+require "test_helper"
+require "hive/commands/setup/preflight"
+
+class SetupPreflightTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_reports_missing_external_dependencies_without_trying_to_install_them
+    calls = []
+    preflight = Hive::Commands::Setup::Preflight.new(
+      which: ->(name) { name == "git" ? "/bin/git" : nil },
+      runner: ->(argv, **_) { calls << argv; { ok: true, stdout: "x 1.0", stderr: "" } },
+      ruby_version: "3.4.1",
+      sqlite_check: -> { true }
+    )
+
+    rows = preflight.call(rails_ready: true)
+
+    assert rows.find { |r| r.name == "git" }.ready?
+    gh = rows.find { |r| r.name == "gh" }
+    refute gh.ready?
+    assert_equal false, gh.hive_owned
+    assert_match(/gh auth login/, gh.remediation)
+    assert_equal [[ "/bin/git", "--version" ]], calls,
+                 "only present tools may be probed; missing external tools must not be installed or invoked"
+  end
+
+  def test_distinguishes_old_ruby_and_owned_web_runtime
+    preflight = Hive::Commands::Setup::Preflight.new(
+      which: ->(_name) { "/bin/tool" },
+      runner: ->(_argv, **_) { { ok: true, stdout: "ok", stderr: "" } },
+      ruby_version: "3.3.9",
+      sqlite_check: -> { false }
+    )
+
+    rows = preflight.call(rails_ready: false)
+
+    ruby = rows.find { |r| r.name == "ruby" }
+    refute ruby.ready?
+    assert_match(/3.4/, ruby.remediation)
+    web = rows.find { |r| r.name == "web runtime" }
+    assert web.hive_owned
+    assert_equal :needs_attention, web.status
+    sqlite = rows.find { |r| r.name == "sqlite" }
+    refute sqlite.ready?
+  end
+end
diff --git a/test/unit/commands/setup/qmd_installer_test.rb b/test/unit/commands/setup/qmd_installer_test.rb
new file mode 100644
index 00000000..c532d9ac
--- /dev/null
+++ b/test/unit/commands/setup/qmd_installer_test.rb
@@ -0,0 +1,44 @@
+require "test_helper"
+require "hive/commands/setup/qmd_installer"
+
+class SetupQmdInstallerTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_installs_into_hive_data_and_preserves_a_user_qmd_link
+    with_xdg_home do
+      qmd_home = File.join(Hive::Paths.data_home, "qmd")
+      user_link = File.join(Hive::Paths.bin_home, "qmd")
+      FileUtils.mkdir_p(File.dirname(user_link))
+      File.write(user_link, "user executable")
+      calls = []
+      installer = Hive::Commands::Setup::QmdInstaller.new(
+        which: ->(name) { name == "npm" ? "npm" : nil },
+        runner: lambda do |argv, **_|
+          calls << argv
+          managed = File.join(qmd_home, "bin", "qmd")
+          FileUtils.mkdir_p(File.dirname(managed))
+          File.write(managed, "#!/bin/sh\n") unless File.exist?(managed)
+          FileUtils.chmod(0o755, managed)
+          { ok: true, stdout: "qmd 1.2.3", stderr: "" }
+        end
+      )
+
+      result = installer.call
+
+      assert_equal :installed, result.status
+      assert_includes calls, [ "npm", "install", "--global", "--prefix", qmd_home, "--no-audit", "--no-fund", "@tobilu/qmd" ]
+      assert_equal "user executable", File.read(user_link)
+      assert_match(/leaving it unchanged/, result.message)
+    end
+  end
+
+  def test_reports_npm_as_an_operator_remediation
+    with_xdg_home do
+      installer = Hive::Commands::Setup::QmdInstaller.new(which: ->(_name) { nil })
+      result = installer.call
+
+      assert_equal :needs_attention, result.status
+      assert_match(/install Node.js\/npm/, result.message)
+    end
+  end
+end
diff --git a/test/unit/commands/setup/web_provisioner_test.rb b/test/unit/commands/setup/web_provisioner_test.rb
new file mode 100644
index 00000000..af602015
--- /dev/null
+++ b/test/unit/commands/setup/web_provisioner_test.rb
@@ -0,0 +1,74 @@
+require "test_helper"
+require "hive/commands/setup/web_provisioner"
+
+class SetupWebProvisionerTest < Minitest::Test
+  include HiveTestHelper
+
+  def with_packaged_web
+    with_tmp_dir do |root|
+      app = File.join(root, "web")
+      FileUtils.mkdir_p(File.join(app, "config"))
+      FileUtils.mkdir_p(File.join(app, "bin"))
+      File.write(File.join(app, "config", "application.rb"), "# app")
+      File.write(File.join(app, "Gemfile"), "source 'https://rubygems.org'\n")
+      File.write(File.join(app, "Gemfile.lock"), "LOCK\n")
+      File.write(File.join(app, "bin", "rails"), "#!/bin/sh\n")
+      FileUtils.chmod(0o755, File.join(app, "bin", "rails"))
+      yield root
+    end
+  end
+
+  def test_provisions_only_xdg_paths_and_is_idempotent
+    with_xdg_home do
+      with_packaged_web do |root|
+        calls = []
+        layout = Hive::Web::RuntimeLayout.new(version: "9.8.7", package_root: root)
+        provisioner = Hive::Commands::Setup::WebProvisioner.new(
+          layout: layout,
+          hive_gem_root: root,
+          runner: ->(env, chdir, argv) { calls << [ env, chdir, argv ]; true }
+        )
+
+        assert_equal :provisioned, provisioner.call.status
+        assert_equal 3, calls.length
+        assert File.file?(File.join(layout.app_dir, "config", "application.rb"))
+        assert File.file?(layout.manifest_path)
+        assert_equal :unchanged, provisioner.call.status
+        assert_equal 3, calls.length
+        assert_equal "#{root}/web", layout.source_app_dir
+      end
+    end
+  end
+
+  def test_failed_provision_keeps_prior_runtime_available
+    with_xdg_home do
+      with_packaged_web do |root|
+        layout = Hive::Web::RuntimeLayout.new(version: "9.8.7", package_root: root)
+        FileUtils.mkdir_p(File.join(layout.app_dir, "config"))
+        File.write(File.join(layout.app_dir, "config", "application.rb"), "# old")
+        File.write(layout.manifest_path, JSON.generate("identity" => { "version" => "old" }))
+        provisioner = Hive::Commands::Setup::WebProvisioner.new(
+          layout: layout, hive_gem_root: root, runner: ->(*) { false }
+        )
+
+        error = assert_raises(Hive::Error) { provisioner.call }
+        assert_match(/bundle install failed/, error.message)
+        assert_equal "# old", File.read(File.join(layout.app_dir, "config", "application.rb"))
+        assert_empty Dir["#{layout.app_dir}.staging-*"]
+      end
+    end
+  end
+
+  def test_sanitizes_inherited_bundler_paths
+    with_xdg_home do
+      with_packaged_web do |root|
+        layout = Hive::Web::RuntimeLayout.new(version: "9.8.7", package_root: root)
+        env = Hive::Commands::Setup::WebProvisioner.new(layout: layout, hive_gem_root: root).runtime_env(layout.staging_dir)
+
+        assert_equal layout.bundle_path, env.fetch("BUNDLE_PATH")
+        assert_equal root, env.fetch("HIVE_WEB_HIVE_GEM_PATH")
+        refute env.key?("BUNDLE_GEMFILE")
+      end
+    end
+  end
+end
diff --git a/test/unit/commands/setup_test.rb b/test/unit/commands/setup_test.rb
new file mode 100644
index 00000000..cc461343
--- /dev/null
+++ b/test/unit/commands/setup_test.rb
@@ -0,0 +1,110 @@
+require "test_helper"
+require "hive/commands/setup"
+
+class SetupCommandTest < Minitest::Test
+  include HiveTestHelper
+
+  Row = Hive::Commands::Setup::Phase
+
+  FakeOutcome = Struct.new(:kind) do
+    def success? = !%i[drifted failed].include?(kind)
+    def drifted? = kind == :drifted
+    def failed? = kind == :failed
+  end
+
+  def ready_preflight(needs_attention: false)
+    row = Hive::Commands::Setup::Preflight::Result
+    [
+      row.new("git", nil, nil, needs_attention ? :needs_attention : :ready, :error, false, "install git", nil),
+      row.new("qmd", nil, nil, :needs_attention, :error, true, "hive setup", nil),
+      row.new("web runtime", nil, nil, :needs_attention, :error, true, "hive setup", nil)
+    ]
+  end
+
+  def build_setup(preflight_rows:, probe: :free, calls: [], web_start_outcome: :unchanged)
+    preflight = Object.new
+    preflight.define_singleton_method(:call) { |rails_ready:| preflight_rows }
+    qmd = Object.new
+    qmd.define_singleton_method(:call) { calls << :qmd; Struct.new(:status).new(:installed) }
+    web = Object.new
+    web.define_singleton_method(:layout) { Struct.new(:completed?).new(false) }
+    web.define_singleton_method(:call) { calls << :web_runtime; Struct.new(:status).new(:provisioned) }
+    daemon = Object.new
+    daemon.define_singleton_method(:install!) { |**_| calls << :daemon; FakeOutcome.new(:written) }
+    web_service = Object.new
+    web_service.define_singleton_method(:install!) { |**_| calls << :web_install; FakeOutcome.new(:written) }
+    web_service.define_singleton_method(:start!) { calls << :web_start; FakeOutcome.new(web_start_outcome) }
+    prompt = Object.new
+    prompt.define_singleton_method(:collect) { %w[claude codex] }
+
+    Hive::Commands::Setup.new(
+      Dir.pwd,
+      preflight: preflight,
+      qmd_installer: qmd,
+      web_provisioner: web,
+      backend_prompt: prompt,
+      project_enroller: ->(_path) { calls << :project; :ready },
+      daemon_installer: daemon,
+      web_installer: web_service,
+      foreground_web: -> { calls << :foreground_web },
+      endpoint_probe: -> { probe },
+      deep_health_probe: -> { true },
+      output: StringIO.new
+    )
+  end
+
+  def test_continues_hive_owned_provisioning_when_external_dependencies_need_attention
+    with_tmp_global_config do
+      calls = []
+      result = build_setup(preflight_rows: ready_preflight(needs_attention: true), calls: calls).call
+
+      assert_equal 1, result.exit_code
+      assert_equal %i[qmd web_runtime project daemon web_install web_start], calls
+      assert result.phases.any? { |phase| phase.name == "git" && phase.status == :needs_attention }
+    end
+  end
+
+  def test_refuses_an_unrelated_port_without_starting_web_service
+    with_tmp_global_config do
+      calls = []
+      result = build_setup(preflight_rows: ready_preflight, probe: :occupied, calls: calls).call
+
+      assert_equal 1, result.exit_code
+      assert_includes calls, :daemon
+      refute_includes calls, :web_start
+      collision = result.phases.find { |phase| phase.name == "web endpoint" }
+      assert_equal :failed, collision.status
+      assert_match(/web.port/, collision.message)
+    end
+  end
+
+  def test_refuses_authless_public_setup_before_writing_web_service
+    with_tmp_global_config do
+      File.write(
+        Hive::Config.global_config_path,
+        { "registered_projects" => [], "web" => { "bind" => "0.0.0.0", "port" => 4567, "auth" => "none" } }.to_yaml
+      )
+      calls = []
+      result = build_setup(preflight_rows: ready_preflight, calls: calls).call
+
+      refute_includes calls, :web_install
+      failure = result.phases.find { |phase| phase.name == "web service" }
+      assert_equal :failed, failure.status
+      assert_match(/unsafe-no-auth/, failure.message)
+    end
+  end
+
+  def test_linux_without_systemd_hands_off_to_foreground_web_after_summary
+    with_tmp_global_config do
+      calls = []
+      result = build_setup(
+        preflight_rows: ready_preflight, calls: calls, web_start_outcome: :autostart_unavailable
+      ).call
+
+      assert_equal 0, result.exit_code
+      assert_equal :fixed, result.phases.find { |phase| phase.name == "web service" }.status
+      assert_equal :foreground_web, calls.last
+      assert_includes calls, :web_start
+    end
+  end
+end
diff --git a/test/unit/commands/uninstall_test.rb b/test/unit/commands/uninstall_test.rb
index 8d1e6be5..4ece1e2a 100644
--- a/test/unit/commands/uninstall_test.rb
+++ b/test/unit/commands/uninstall_test.rb
@@ -82,13 +82,15 @@ class UninstallCommandTest < Minitest::Test
     with_xdg_home do
       versioned = File.join(Hive::Paths.data_home, "1.2.3")
       named = File.join(Hive::Paths.data_home, "vnext")
+      web_runtime = File.join(Hive::Paths.data_home, "web", "1.0.0")
       kept = File.join(Hive::Paths.data_home, "notes")
-      [ versioned, named, kept ].each { |path| FileUtils.mkdir_p(path) }
+      [ versioned, named, web_runtime, kept ].each { |path| FileUtils.mkdir_p(path) }
 
       Hive::Commands::Uninstall.new(output: StringIO.new).send(:remove_data_versions)
 
       refute File.exist?(versioned)
       refute File.exist?(named)
+      refute File.exist?(web_runtime), "web runtime is package cache, not durable web state"
       assert File.exist?(kept)
     end
   end
diff --git a/test/unit/commands/web/service_installer_test.rb b/test/unit/commands/web/service_installer_test.rb
new file mode 100644
index 00000000..ae6aa401
--- /dev/null
+++ b/test/unit/commands/web/service_installer_test.rb
@@ -0,0 +1,64 @@
+require "test_helper"
+require "hive/commands/web/service_installer"
+
+class WebServiceInstallerTest < Minitest::Test
+  include HiveTestHelper
+
+  def config(bind: "127.0.0.1", port: 4567, auth: "auto")
+    { "bind" => bind, "port" => port, "auth" => auth }
+  end
+
+  def test_linux_renders_separate_web_unit_with_xdg_environment
+    with_xdg_home do
+      with_tmp_dir do |dir|
+        commands = []
+        installer = Hive::Commands::Web::ServiceInstaller.new(
+          config: config, host_os: "linux", home: dir, binary_path: "/opt/hive/bin/hive",
+          systemctl_available: true, runner: ->(argv) { commands << argv; true }
+        )
+
+        result = installer.install!(autostart: false)
+        unit = File.read(installer.target_path)
+
+        assert_equal :written, result.kind
+        assert_includes unit, "ExecStart=/opt/hive/bin/hive web"
+        assert_includes unit, "Description=Hive local web UI"
+        assert_includes unit, "XDG_CONFIG_HOME=#{ENV.fetch('XDG_CONFIG_HOME')}"
+        refute_includes unit, "hive-daemon"
+        assert_empty commands
+      end
+    end
+  end
+
+  def test_start_requires_an_installed_unit_and_enables_only_web
+    with_tmp_dir do |dir|
+      calls = []
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        config: config, host_os: "linux", home: dir, binary_path: "/tmp/hive",
+        systemctl_available: true, runner: ->(argv) { calls << argv; true }
+      )
+
+      error = assert_raises(Hive::Error) { installer.start! }
+      assert_match(/hive web install/, error.message)
+      installer.install!(autostart: false)
+      assert_equal :unchanged, installer.start!.kind
+      assert_includes calls, %w[systemctl --user daemon-reload]
+      assert_includes calls, %w[systemctl --user enable --now hive-web]
+      refute calls.flatten.include?("hive-daemon")
+    end
+  end
+
+  def test_launchd_uses_a_missing_binary_circuit_breaker_and_unsafe_flag_only_when_requested
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        config: config(bind: "0.0.0.0", auth: "none"), unsafe_no_auth: true,
+        host_os: "darwin", home: dir, binary_path: "/opt/hive/bin/hive", runner: ->(_) { true }
+      )
+      installer.install!(autostart: false)
+      plist = File.read(installer.target_path)
+
+      assert_includes plist, "[ -x \"$0\" ] || exit 0"
+      assert_includes plist, "--unsafe-no-auth"
+    end
+  end
+end
diff --git a/test/unit/daemon/health_test.rb b/test/unit/daemon/health_test.rb
new file mode 100644
index 00000000..00784f1b
--- /dev/null
+++ b/test/unit/daemon/health_test.rb
@@ -0,0 +1,52 @@
+require "test_helper"
+require "hive/daemon/health"
+
+class DaemonHealthTest < Minitest::Test
+  include HiveTestHelper
+
+  def health(payload: nil, alive: true, service_state: { "service_installed" => true })
+    Hive::Daemon::Health.new(
+      payload: payload,
+      current_binary: "/usr/local/bin/hive",
+      current_version: "1.2.3",
+      process_alive: ->(_pid) { alive },
+      process_owned: ->(_payload, _pid) { true },
+      service_state: service_state
+    ).call
+  end
+
+  def payload(overrides = {})
+    {
+      "pid" => 123,
+      "process_start_time" => "start",
+      "invoked_binary" => "/usr/local/bin/hive",
+      "hive_version" => "1.2.3"
+    }.merge(overrides)
+  end
+
+  def test_matching_identity_is_healthy
+    result = health(payload: payload)
+
+    assert_equal :match, result.state
+    assert_empty result.mismatches
+  end
+
+  def test_stale_and_legacy_payloads_are_not_false_matches
+    assert_equal :stopped, health(payload: payload, alive: false).state
+    assert_equal :unknown, health(payload: payload("invoked_binary" => nil)).state
+  end
+
+  def test_version_and_wrapper_drift_are_actionable
+    result = health(payload: payload("hive_version" => "1.0.0", "invoked_binary" => "/old/hive"))
+
+    assert_equal :mismatch, result.state
+    assert_equal %w[hive_version invoked_binary], result.mismatches.sort
+    assert_match(/repair/, result.remediation)
+  end
+
+  def test_running_daemon_without_a_unit_is_unmanaged
+    result = health(payload: payload, service_state: { "service_installed" => false })
+
+    assert_equal :unmanaged, result.state
+  end
+end
diff --git a/test/unit/daemon/repair_test.rb b/test/unit/daemon/repair_test.rb
new file mode 100644
index 00000000..071fa9c2
--- /dev/null
+++ b/test/unit/daemon/repair_test.rb
@@ -0,0 +1,30 @@
+require "test_helper"
+require "hive/daemon/repair"
+
+class DaemonRepairTest < Minitest::Test
+  FakeInstaller = Struct.new(:calls) do
+    def install!(autostart:, force:)
+      calls << [ :install, autostart, force ]
+      Hive::Commands::ServiceInstaller::Outcome.new(:upgraded, backup_path: "/tmp/unit.bak")
+    end
+  end
+
+  def test_force_repairs_a_managed_unit_and_waits_for_matching_identity
+    states = [
+      Hive::Daemon::Health::Result.new(:mismatch, {}, [ "hive_version" ], "repair", {}),
+      Hive::Daemon::Health::Result.new(:match, {}, [], "ok", {})
+    ]
+    installer = FakeInstaller.new([])
+    repair = Hive::Daemon::Repair.new(
+      installer: installer,
+      health: -> { states.shift || states.last },
+      sleeper: ->(_seconds) {}, timeout: 1
+    )
+
+    result = repair.call
+
+    assert_equal :repaired, result.status
+    assert_equal "/tmp/unit.bak", result.backup_path
+    assert_equal [ [ :install, true, true ] ], installer.calls
+  end
+end
diff --git a/test/unit/gemspec_test.rb b/test/unit/gemspec_test.rb
index a4ddfc6e..a0cae069 100644
--- a/test/unit/gemspec_test.rb
+++ b/test/unit/gemspec_test.rb
@@ -25,14 +25,14 @@ class GemspecTest < Minitest::Test
     assert_includes spec.files, "bin/hv"
   end
 
-  # The web tier is a Rails app under web/, supported only in the Docker
-  # image or a source checkout — the gem must stay a lean CLI and not
-  # package the app or its old Sinatra-era assets.
-  def test_gem_package_excludes_the_rails_web_app
+  def test_gem_package_includes_the_rails_web_runtime_but_not_test_or_mutable_output
     spec = Gem::Specification.load(GEMSPEC_PATH)
 
-    refute spec.files.any? { |f| f.start_with?("web/") },
-           "the Rails app must not ship inside the gem"
+    %w[web/Gemfile web/Gemfile.lock web/config/application.rb web/bin/rails web/db/cache_schema.rb].each do |path|
+      assert_includes spec.files, path
+    end
+    refute spec.files.any? { |f| f.start_with?("web/test/") }
+    refute spec.files.any? { |f| f.start_with?("web/tmp/") || f.start_with?("web/log/") || f.start_with?("web/storage/") }
     refute spec.files.any? { |f| f.start_with?("public/") },
            "no Sinatra-era static assets should be packaged"
   end
